# TPK4186 - Advanced Tools for Performance Engineering
# FileCapitalizeIdentifiers.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Keywords
def IsPythonKeyword(identifier):
  if identifier=="def":
    return True
  if identifier=="else":
    return True
  if identifier=="for":
    return True
  if identifier=="if":
    return True
  if identifier=="in":
    return True
  if identifier=="print":
    return True
  if identifier=="range":
    return True
  if identifier=="return":
    return True
  if identifier=="str":
    return True
  return False

# Capitalization of an identifier
def CapitalizeIdentifier(sourceIdentifier):
  if IsPythonKeyword(sourceIdentifier):
    return sourceIdentifier
  targetIdentifier = ""
  firstCharacterInWord = True
  for character in sourceIdentifier:
    if firstCharacterInWord:
      targetIdentifier += character.upper()
      firstCharacterInWord = False  
    elif character=="_":
      firstCharacterInWord = True
    else:
      targetIdentifier += character
  return targetIdentifier

def FileCapitalizeIdentifiers(sourceFileName, targetFileName):
  try:
    sourceFile = open(sourceFileName, "r") 
  except: 
    print("Unable to open file " + sourceFileName)
    return 1
  try:
    targetFile = open(targetFileName, "w") 
  except: 
    print("Unable to open file " + targetFileName)
    sourceFile.close()
    return 1
  for line in sourceFile:
    isComment = False
    sourceIdentifier = ""
    for chr in line:
      if chr=='\n':
        if sourceIdentifier!="":
          targetIdentifier = CapitalizeIdentifier(sourceIdentifier)
          targetFile.write(targetIdentifier)
          sourceIdentifier = ""
        targetFile.write(chr)
      elif chr=='#':
        if sourceIdentifier!="":
          targetIdentifier = CapitalizeIdentifier(sourceIdentifier)
          targetFile.write(targetIdentifier)
          sourceIdentifier = ""
        targetFile.write(chr)
        isComment = True
      elif isComment:
        targetFile.write(chr)
      elif sourceIdentifier=="":
        if chr=='_' or chr.isalpha():
           sourceIdentifier = chr
        else:
          targetFile.write(chr)
      else:
        if chr=='_' or chr.isalnum():
          sourceIdentifier += chr
        else:
          targetIdentifier = CapitalizeIdentifier(sourceIdentifier)
          targetFile.write(targetIdentifier)
          sourceIdentifier = ""
          targetFile.write(chr)
  targetFile.flush()
  targetFile.close()
  sourceFile.close()
  return 0


# Tests
FileCapitalizeIdentifiers("SourceFibonacci.py", "TargetFibonacci.py")
