# TPK4186 - Advanced Tools for Performance Engineering
# SourceFibonacci.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Recursive version
def fibonacci_recursive(n):
  if n==0:
    return 1
  if n==1:
    return 1
  return fibonacci_recursive(n-1) + fibonacci_recursive(n-2)

print("fibonacci_recursive(30) = " + str(fibonacci_recursive(30)))
print("fibonacci_recursive(32) = " + str(fibonacci_recursive(32)))
print("fibonacci_recursive(34) = " + str(fibonacci_recursive(34)))
print("fibonacci_recursive(36) = " + str(fibonacci_recursive(36)))

# Version with a loop
def fibonacci_loop(n):
  f0 = 1
  f1 = 1
  for i in range(2, n+1):
    f2 = f1 + f0
    f0 = f1
    f1 = f2
  return f1

print("fibonacci_loop(30) = " + str(fibonacci_loop(30)))
print("fibonacci_loop(32) = " + str(fibonacci_loop(32)))
print("fibonacci_loop(34) = " + str(fibonacci_loop(34)))
print("fibonacci_loop(36) = " + str(fibonacci_loop(36)))
