# TPK4186 - Advanced Tools for Performance Engineering
# ComponentUnreliability.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.


# Required modules
import math

# Negative exponential distribution
def nexp(rate, t):
  return 1-math.exp(-rate*t)

# template
def CreateLine(code, rate):
  template = "{code:<6s}{rate:1.2e} {U1000:1.2e} {U2000:1.2e} {U10000:1.2e}\n"
  U1000 = nexp(rate, 1000)
  U2000 = nexp(rate, 2000)
  U10000 = nexp(rate, 10000)
  return template.format(code=code, rate=rate, U1000=U1000, U2000=U2000, U10000=U10000)

# file opening
fileName = "Unreliabilities.txt"
try:
  file = open(fileName, "w")
except:
  print("Unable to open file " + fileName)
  sys.exit()

file.write(CreateLine("SDV", 0.00000123))
file.write(CreateLine("SV", 0.00000345))
file.write(CreateLine("EPMP", 0.0000789))

file.flush()
file.close()
