# TPK4186 - Advanced Tools for Performance Engineering
# CountingWordsAndSentences.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import re

# Counting
inputFileName = "Lorem Ipsum.txt"

try:
  inputFile = open(inputFileName, "r")
except:
  print("Unable to open file " + inputFileName)
  sys.exit()

numberOfWords = 0
numberOfSentences = 0
for line in inputFile:
  line = line.rstrip()
  words = re.findall(r"[A-Za-z]+", line)
  numberOfWords += len(words)
  dots = re.findall(r"\.", line)
  numberOfSentences += len(dots)

print("#words    \t" + str(numberOfWords))
print("#sentences\t" + str(numberOfSentences))
inputFile.close()
