# TPK4186 - Advanced Tools for Performance Engineering
# LicensePlatesGenerator.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import re
import random

# Generator
random.seed(12345)
fileName = "licensePlates.txt"
numberOfPlates = 1000
regularVehicleRatio = 0.80
motorcycleRatio = 0.15
spaceRatio = 0.6

letterRatio = 0.4
numberRatio = 0.5


output = open(fileName, "w")
for n in range(0, numberOfPlates):
  vehicleChoice = random.uniform(0.0, 1.0)
  if vehicleChoice<=regularVehicleRatio:
    licensePlate = chr(random.randrange(ord('A'), ord('A') + 26))
    licensePlate += chr(random.randrange(ord('A'), ord('A') + 26))
    if random.uniform(0.0, 1.0)<=spaceRatio:
      licensePlate += " "
    licensePlate += str(random.randrange(10000, 99999))
  elif vehicleChoice<=regularVehicleRatio+motorcycleRatio:
    licensePlate = chr(random.randrange(ord('A'), ord('A') + 26))
    licensePlate += chr(random.randrange(ord('A'), ord('A') + 26))
    if random.uniform(0.0, 1.0)<=spaceRatio:
      licensePlate += " "
    licensePlate += str(random.randrange(1000, 9999))
  else:
    licensePlate = ""
    size = random.randint(4, 10)
    for i in range(0, size):
      characterChoice = random.uniform(0.0, 1.0)
      if characterChoice<=letterRatio:
        licensePlate += chr(random.randrange(ord('A'), ord('A') + 26))
      elif characterChoice<=letterRatio+numberRatio:
        licensePlate += chr(random.randrange(ord('0'), ord('0') + 10))
      else:
        licensePlate += " "
  output.write(licensePlate + "\n")

output.flush()
output.close
