# TPK4186 - Advanced Tools for Performance Engineering
# DNASequencing.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import re

# Reading the input file
inputFileName = "DNASequence.txt"

try:
  inputFile = open(inputFileName, "r")
except:
  print("Unable to open file " + inputFileName)
  sys.exit()

sequence = ""
for line in inputFile:
  line = line.rstrip()
  sequence += line
inputFile.close()

# Q1
if re.search(r"GAATTC", sequence):
  print("The sequence contains a 'GAATTC'")

# Q2
tokens = re.findall(r"GAATTC", sequence)
print("The sequence contains " + str(len(tokens)) + " 'GAATTC'")

# Q3
tokens = re.findall(r"GG(A|T)CC", sequence)
print("The sequence contains " + str(len(tokens)) + " 'GG(A|T)CC'")

# Q4
tokens = re.findall(r"A{3}.C", sequence)
print("The sequence contains " + str(len(tokens)) + " 'AAA.C'")

# Q5
tokens = re.findall(r"(A|C).T", sequence)
print("The sequence contains " + str(len(tokens)) + " '(A|C).T'")

# Q6
tokens = re.findall(r"C[^G]A{3,5}[^A]", sequence)
print("The sequence contains " + str(len(tokens)) + " 'C[^G]A{3,5}[^A]'")

# Q7
tokens = re.findall(r"G{3}A+T{3}", sequence)
print("The sequence contains " + str(len(tokens)) + " 'G{3}A+T{3}'")

# Q8
tokens = re.findall(r"[^AT][AT]{5,}[^AT]", sequence)
print("The sequence contains " + str(len(tokens)) + " '[^AT][AT]{5,}[^AT]'")

# Q9
tokens = re.findall(r"(.{3})\1", sequence)
print("The sequence contains " + str(len(tokens)) + " '(.{3})\\1'")

# Q10
p = re.compile(r"(.{4})\1")
for m in p.finditer(sequence):
    print(m.start(), m.group())
